<template>
  <q-form @submit="doVerifyEmail(form)">
    <div class="row">
      <div class="col-12 flex justify-center">
        <v-otp-input
          v-model="form.verification_code"
          ref="otpInput"
          input-classes="otp-input"
          separator=""
          :num-inputs="6"
          :should-auto-focus="true"
          @on-change="handleOnChange"
          @on-complete="handleOnComplete"
          :rules="[validations.requiredField]"
        />
      </div>

      <div class="col-12">
        <p class="text-center text__secondary title-4 q-mt-xl">
          Didn't receive it?
          <a
            class="text__tertiary title-4 font-weight-bold text-decoration-none"
            @click="doResendCode"
          >
            Resend Code
          </a>
        </p>
      </div>
    </div>

    <div class="q-mt-xl">
      <p class="text-negative text-center">
        {{ errorMessage }}
      </p>
      <div class="row">
        <div class="col flex justify-center">
          <q-btn
            unelevated
            type="submit"
            class="btn-xl btn--shade-1 title-4 text-white rounded-borders-10"
            :loading="loading"
            label="Submit"
          />
        </div>
      </div>
    </div>
  </q-form>
</template>

<script>
import { AuthApi } from "src/hooks/api";
import { defineComponent, ref, reactive, computed } from "vue";
import { requiredField } from "src/hooks/validations";
import { LocalStorage } from "quasar";
import useAuthHook from "src/modules/auth/hooks/authHook";
import usePageRouter from "src/hooks/pageRouter";
import VOtpInput from "vue3-otp-input";

export default defineComponent({
  name: "VerificationCodeForm",
  components: {
    VOtpInput,
  },

  setup() {
    const { loading, doResendCode } = useAuthHook();
    const { router } = usePageRouter();
    const otpInput = ref(null);
    const isError = ref(false);
    const errorMessage = ref("");

    const form = reactive({
      verification_code: "",
      email: LocalStorage.getItem("userForm").email,
    });

    const handleOnComplete = (value) => {
      form.verification_code = value;
    };

    const handleOnChange = (value) => {
      form.verification_code = value;
    };

    const doVerifyEmail = async (form) => {
      loading.value = true;

      await AuthApi.verifyEmail(form)
        .then((response) => {
          setTimeout(() => {
            if (response.data.success === true) {
              router.push("onboarding-jobseeker");
            }
          }, 1000);
        })
        .catch((error) => {
          isError.value = true;
          if (error.response.data.message === "Code is incorrect.") {
            errorMessage.value = "INVALID CODE";
          } else {
            errorMessage.value = error?.response?.data?.message.toUpperCase();
          }
        })
        .finally(() => {
          loading.value = false;
        });
    };

    return {
      otpInput,
      form,
      isError,
      errorMessage,
      loading,
      doVerifyEmail,
      doResendCode,
      handleOnComplete,
      handleOnChange,
      validations: {
        requiredField,
      },
    };
  },
});
</script>

<style>
.otp-input {
  width: 40px;
  height: 40px;
  padding: 5px;
  margin: 0 10px;
  font-size: 20px;
  border-radius: 10px;
  border: 1px solid rgba(0, 0, 0, 0.3);
  text-align: center;
}
/* Background colour of an input field with value */
.otp-input.is-complete {
  border-color: primary;
}
.otp-input::-webkit-inner-spin-button,
.otp-input::-webkit-outer-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
input::placeholder {
  font-size: 15px;
  text-align: center;
  font-weight: 600;
}

a {
  cursor: pointer;
}
</style>
